﻿using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using System.Windows.Media;
using Microsoft.Phone.Controls;

namespace ElementHandledDemo
{
    public partial class MainPage : PhoneApplicationPage
    {
        public MainPage()
        {
            InitializeComponent();
            SupportedOrientations = SupportedPageOrientation.Portrait | SupportedPageOrientation.Landscape;
        }

        void OnRectangleManipulationStarted(object sender, 
                                            ManipulationStartedEventArgs args)
        {
            // Bring touched element to top
            Panel pnl = (args.ManipulationContainer as FrameworkElement).Parent as Panel;

            for (int i = 0; i < pnl.Children.Count; i++)
            {
                UIElement child = pnl.Children[i];
                Canvas.SetZIndex(child, 
                    child == args.ManipulationContainer ? pnl.Children.Count : i);
            }
            args.Handled = true;
        }

        void OnRectangleManipulationDelta(object sender, 
                                          ManipulationDeltaEventArgs args)
        {
            // Set Transform of touched element
            TranslateTransform xform = 
                args.ManipulationContainer.RenderTransform as TranslateTransform;
            Point translation = args.DeltaManipulation.Translation;

            switch (this.Orientation)
            {
                case PageOrientation.PortraitUp:
                    xform.X += translation.X;
                    xform.Y += translation.Y;
                    break;

                case PageOrientation.PortraitDown:
                    xform.X -= translation.X;
                    xform.Y -= translation.Y;
                    break;

                case PageOrientation.LandscapeLeft:
                    xform.X += translation.Y;
                    xform.Y -= translation.X;
                    break;

                case PageOrientation.LandscapeRight:
                    xform.X -= translation.Y;
                    xform.Y += translation.X;
                    break;
            }
            args.Handled = true;
        }
    }
}