﻿using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;

namespace PageHandledDemo
{
    public partial class MainPage : PhoneApplicationPage
    {
        public MainPage()
        {
            InitializeComponent();
            SupportedOrientations = SupportedPageOrientation.Portrait | SupportedPageOrientation.Landscape;
        }

        protected override void OnManipulationStarted(ManipulationStartedEventArgs args)
        {
            if (args.ManipulationContainer is Rectangle)
            {
                // Bring touched element to top
                for (int i = 0; i < ContentGrid.Children.Count; i++)
                {
                    UIElement child = ContentGrid.Children[i];
                    Canvas.SetZIndex(child, child == args.ManipulationContainer ? ContentGrid.Children.Count : i);
                }
                args.Handled = true;
            }
            base.OnManipulationStarted(args);
        }

        protected override void OnManipulationDelta(ManipulationDeltaEventArgs args)
        {
            if (args.ManipulationContainer is Rectangle)
            {
                // Set Transform of touched element
                TranslateTransform xform = args.ManipulationContainer.RenderTransform as TranslateTransform;
                Point translation = args.DeltaManipulation.Translation;

                switch (this.Orientation)
                {
                    case PageOrientation.PortraitUp:
                        xform.X += translation.X;
                        xform.Y += translation.Y;
                        break;

                    case PageOrientation.PortraitDown:
                        xform.X -= translation.X;
                        xform.Y -= translation.Y;
                        break;

                    case PageOrientation.LandscapeLeft:
                        xform.X += translation.Y;
                        xform.Y -= translation.X;
                        break;

                    case PageOrientation.LandscapeRight:
                        xform.X -= translation.Y;
                        xform.Y += translation.X;
                        break;
                }
                args.Handled = true;
            }
            base.OnManipulationDelta(args);
        }
    }
}